<!DOCTYPE html>
<html>
	<body>
		<p>Click the button to solve question 2 of satck</p>
		<button onclick="bracketNumber()">print the bracket number</button>
        <p id="demo"></p>
        
		<script>
			function bracketNumber() {
				class Stack {
				// Array is used to implement stack
					constructor() {
						this.items = [];
					}
				
					// push function
					push(element) {
						// push element into the items
						this.items.push(element);
					}
				
					// pop
					pop() {
						// function return top most element in the stack and removes it from the stack Underflow if stack is empty
						if(this.items.length == 0)
							return "Underflow";
						return this.items.pop();
					}
				
					// peek function
					peek() {
						// return the top most element from the stack but does'nt delete it.
						return this.items[this.items.length - 1];
					}

				}

                function printBracket(str,n) { 
                    // used to print the bracket number for left bracket 
                    var left = 1; 
                    var strNumber = "";
                    
                    // used to obtain the bracket number for the open bracket 
                    var right = new Stack(); 
                    
                    // traverse the given string 
                    for (var i = 0; i < n; i++) { 
                        
                        // if current character is a left bracket 
                        if (str[i] == '(') { 
                            // print left 
                            strNumber += left; 
                            
                            // push left on to the stack 
                            right.push(left); 
                            
                            // increment left by 1 
                            left++; 
                        } 
                        
                        // else if current character is a right bracket 
                        else if(str[i] == ')') { 
                
                            // print the top element of stack 'right' 
                            strNumber += right.peek(); 
                            
                            // pop the top element from the stack 
                            right.pop(); 
                        } 
                    } 
                    return(strNumber);
                }

                var str = prompt(`Please enter a string for which you want to number the brackets `);
                //your string
                console.log(str);
                //print bracket numbers
                console.log(printBracket(str,str.length));
            }

		</script>

	</body>
</html>